/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2013  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * example of defaults
 */

/*set debug_level =6.
set print_level =10.
set verbosity = 4.
*/

/* run */ define test1a() = {
    exists I,J : { skip and I defaults 4 and R is ref I and I:=2 and always (format("I=%d\n",I)) }
}.

/* run */ define test1b() = {
    exists I,J : { skip and I defaults 4 and I:=2 and always output(I) }
}.

/* run */ define test3a() = {
    exists I,J : {  skip and  I=2 and always format("I=%d\n",I) and I defaults 4 }
}.

/* run */ define test3b() = {
    exists I,J : {  skip and  I=2 and always output(I) and I defaults 4 }
}.

/* run */ define test4a() = {
    exists I,J : { skip and I:=2 and always format("I=%d\n",I) }
}.

/* run */ define test4b() = {
    exists I,J : { skip and I:=2 and always output(I) }
}.

/* run */ define test5a() = {
    exists I,J : { len(4) and I defaults 4 and J is I+1 and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test5b() = {
    exists I,J : { len(4) and I defaults 4 and J is I+1 and always (output(I) and output(J)) }
}.

/* run */ define test6a() = {
    exists I,J : { len(4) and I defaults 4 and I defaults 2 and J is I+1 and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test6b() = {
    exists I,J : { len(4) and I defaults 4 and I defaults 2 and J is I+1 and always (output(I) and output(J)) }
}.

/* run */ define test7a() = {
    exists I,J : { len(4) and I=4 and next(I) defaults  I and J is I+1 and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test7b() = {
    exists I,J : { len(4) and I=4 and next(I) defaults  I and J is I+1 and always (output(I) and output(J)) }
}.

/* run */ define test8a() = {
    exists I,J : { len(4) and I=4 and mem(I) and J is I and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test8b() = {
    exists I,J : { len(4) and I=4 and mem(I) and J is I and always (output(I) and output(J)) }
}.

/* run */ define test9a() = {
    exists I,J : { len(4) and I=4 and I:=2 and mem(I) and J is I+1 and always (format("I=%d J=%d\n",I,J)) }
}.

/* run */ define test9b() = {
    exists I,J : { len(4) and I=4 and I:=2 and mem(I) and J is I+1 and always (output(I) and output(J)) }
}.

/* run */ define test10a() = {
   exists X :{    
     mem(X)  and len(4) and X=0  and
     always (format("X=%d\n",X)) and
     {{skip and X:=X+1};skip;skip;skip} and
     {skip;skip;{skip and X:=X+1};skip}
   }
}.

/* run */ define test10b() = {
   exists X :{    
     mem(X)  and len(4) and X=0  and
     always (output X) and
     {{skip and X:=X+1};skip;skip;skip} and
     {skip;skip;{skip and X:=X+1};skip}
   }
}.

/* run */ define test11a() = {
    exists I,J,L : { list(L,3) and stable(struct(L)) and len(4) and
                     I=0 and L=[0,1,2] and L:=[4,5,6] and 
                     L[0] defaults 1 and L[1] defaults 2 and L[2] defaults 3
                     and I defaults 1 and J is L[I] and
                     always (format("I=%d J=%d L=%t\n",I,J,L)) }
}.

/* run */ define test11b() = {
    exists I,J,L : { list(L,3) and stable(struct(L)) and len(4) and
                     I=0 and L=[0,1,2] and L:=[4,5,6] and 
                     L[0] defaults 1 and L[1] defaults 2 and L[2] defaults 3
                     and I defaults 1 and J is L[I] and
                     always (output(I) and output(J) and output(L)) }
}.

/* run */ define test12a() = {
    exists I,J,L : { list(L,3) and stable(struct(L)) and len(4) and
                     I=0 and L=[0,1,2] and L:=[4,5,6] and
                     (skip;skip;(L[1]=9 and skip);L=[7,6,3]) and
                     mem(L[0]) and mem(L[1]) and mem(L[2])
                     and I defaults 1 and J is L[I] and
                     always (format("I=%d J=%d L=%t\n",I,J,L)) }
}.
          /* bug */
/* run */ define test12b() = {
    exists I,J,L : { list(L,3) and stable(struct(L)) and len(4) and
                     I=0 and L=[0,1,2] and L:=[4,5,6] and
                     (skip;skip;(L[1]=9 and skip);L=[7,6,3]) and
                     mem(L[0]) and mem(L[1]) and mem(L[2])
                     and I defaults 1 and J is L[I] and
                     always (output(I) and output(J) and output(L)) }
}.

/* run */ define test13a() = {
    exists X : { X defaults 4 and (skip;{output(X) and empty} ; {X = 0 and empty}) }

}.

/* run */ define test13b() = {
    exists X : { mem(X) and always(output(X)) and X=4 and (skip;{output(X) and empty} ; {X = 0 and empty}) }

}.

/* run */ define test14() = {
    exists X : { X defaults 4 and always (output(X)) and
                 ({skip and next(output(X))} ; {X = 0 and empty};skip) }

}.
