/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2013  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * 
 */

/* run */ define test0() = {
    exists X,Y : 
    {
        set precision=5 and
        X=$2.3333555$ and Y=$1.2e+01$ and stable(Y) and len(10) and
        format("Y=%9e\n",Y) and 
        X gets X+Y and always format("X=%9f | X+Y=%9e \n",X,X)
    }
}.
    
/* run */ define test1() = {
    exists X : 
    {
        set precision=7 and
        X=$2.3333555$ and len(10) and X gets sqrt(X) and 
        always format("X=%9f | sqrt(X)=%9f \n",X,sqrt(X))
    }
}.          

/* run */ define test2() = {
    exists X,Y : 
    {
        set precision=7 and
        X=$2.3333555$ and Y=1 and stable(Y) and len(10) and
        X gets sqrt(X) + itof(Y) and format("Y=%d\n",Y) and 
        always format("X=%9f | sqrt(X)+itof(Y)=%9f \n",X,sqrt(X)+itof(Y))
    }
}.

/* run */ define test3() = {
    exists X,Y : 
    {
        set precision=7 and
        X=$1.9333555$ and Y=1 and stable(Y) and len(10) and
        X gets sqrt(X) + itof(Y) and format("Y=%d\n",Y) and 
        always format("X=%9f | sqrt(X)+itof(Y)=%9f | ceil(sqrt(X)+itof(Y))=%d \n",X,sqrt(X)+itof(Y),ceil(sqrt(X)+itof(Y)))
    }
}.

/* run */ define test4() = {
    exists X,Y : 
    {
        set precision=7 and X=$1.9999999$ and len(20) and  
        X gets sqrt(X) and 
        always format("X=%9f | sqrt(X)=%9f | floor(sqrt(X))=%d \n",X,sqrt(X),floor(sqrt(X)))
    }
}.


/* run */ define test5() = {
    exists X : 
    {
        set precision=10 and len(20) and  set frandom_seed = 3 and
        always format("frandom=%f \n",frandom)
    }
}.
